//----------------------------------------------------------------
//	File:		graph.java
//	Purpose:	Implement a directed, weighted graph class via an 
//              Adjacency Matrix
//  Author : 
//  Last Modified : 
//  Comments : 
//----------------------------------------------------------------

import java.io.*;

public class Graph { 

private int numEdges;
private int numVertices;
private double [][] M; 
private final double NO_EDGE = 1.0e100;	//define NO_EDGE's value for class

public Graph(){
  numEdges = 0; numVertices = 0;
}

public Graph(int n) {
  // complete
}

public void initialize(String fileName){
    FileInput myFile = new FileInput(fileName); 
    int first = 0, second=0, third=0; 
    String next="";
	while (!myFile.eof()){
	  if (numEdges==0)
	    { numVertices = myFile.getInt();
	      M = new double[numVertices][numVertices];
	      for (int i=0; i<numVertices; i++)
            for (int j=0; j<numVertices ; j++)
              M[i][j] = NO_EDGE;
	    }
	  else
	    { first = myFile.getInt();
	      second = myFile.getInt();
	      third = myFile.getInt();
	      M[first][second]=third;
	    }
	  numEdges++;
	}   
	     
	
      
}


public void setSize(int n) 
{
	// complete
}

public void addEdge(int origin, int destination, double value) 
{
	// complete
}

public void removeEdge(int origin, int destination) 
{
	// complete
}

public boolean hasEdge(int origin, int destination)
{
   // complete
}

// return true if there is any path from origin to destination
public boolean hasPath(int origin, int destination){


}
// retunr the path length from origin to destination
public int pathLength(int origin, int destination){

}
//  return true if for each edge from i to j, there is an edge from j to i
public boolean isSymmetric(){

}

//  retunr the total number of one way edges (if (i,j) is there then (j,i) is not there
// and vice versa
public int oneWay(){

}

public double edgeValue(int origin, int destination)
{
  // complete
}

public int inDegree(int n){
 // complete
}

public int outDegree(int n){
  // complete
}

public int degree(int n){
  return (inDegree(n)+outDegree(n));
}

public int getVertices(){
    return numVertices;
}

public void print() {
   for (int i=0; i<numVertices ;i++)
    { System.out.print(i + "==>");
      for (int j=0; j<numVertices; j++)
        if (hasEdge(i,j))
           System.out.print(j + " ");
      System.out.println();
     }      
}

}

